Bug 472337 - Review Request: fabric - A simple pythonic remote deployment tool
Review Request: fabric - A simple pythonic remote deployment tool
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jonathan Steffan
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-20 00:52 EST by Silas Sewell
Modified: 2013-07-31 08:17 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-04-12 14:59:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
athmanem: fedora‑review-
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Silas Sewell 2008-11-20 00:52:20 EST
Spec URL: http://silassewell.googlecode.com/svn/trunk/projects/rpm/fabric/fabric.spec
SRPM URL: http://silassewell.googlecode.com/svn/trunk/projects/rpm/fabric/fabric-0.0.9-1.fc9.src.rpm
Description: Fabric is a simple pythonic remote deployment tool which is designed to upload files to, and run shell commands on, a number of servers in parallel or serially.

This is my first package and as such I'll need a sponsor.
Comment 1 Fabian Affolter 2008-11-20 08:43:30 EST
Just some quick comments on your spec file (without any deep investigation ;-) ):

- 'License: GPLv2' The license should be GPLv2+. Take a look at the headers of the source: "or (at your option) any later version"

- Replace 'BuildRequires: python-devel' with 'BuildRequires: python'
  https://fedoraproject.org/wiki/Packaging/Python#BuildRequires

- Do you really need 'Requires: python-setuptools' ?

- add TODO to %doc

- 'Requires: python-paramiko < 2' is from my point of view not necessary because the current version of paramiko is 1.7.4
Comment 2 Fabian Affolter 2008-11-20 08:48:22 EST
I can't sponsor you because I'm not a sponsor.  I suggest that you follow this document to get sponsored.
https://fedoraproject.org/wiki/PackageMaintainers/HowToGetSponsored
Comment 3 Silas Sewell 2008-11-20 10:32:42 EST
(In reply to comment #1)
> - 'License: GPLv2' The license should be GPLv2+. Take a look at the headers of
> the source: "or (at your option) any later version"

Fixed.

> - Replace 'BuildRequires: python-devel' with 'BuildRequires: python'
>   https://fedoraproject.org/wiki/Packaging/Python#BuildRequires

Fixed.

> - Do you really need 'Requires: python-setuptools' ?

Yes, it is a requirement.

> - add TODO to %doc

Fixed.

> - 'Requires: python-paramiko < 2' is from my point of view not necessary
> because the current version of paramiko is 1.7.4

Fixed (the only reason I added this was because it was explicitly set in the egg).


Thanks for your feedback.
Comment 4 Fabian Affolter 2008-11-20 19:53:57 EST
Please bump the release of your spec file if you made any changes and add a changelog entry. 

https://fedoraproject.org/wiki/Packaging/Guidelines#Changelogs

At the moment your entry ends with '...ll.ch> - 0.0.9.-1' 

rpmlint complains about this:

fabric.noarch: W: incoherent-version-in-changelog 0.0.9.-1 ['0.0.9-1.fc10', '0.0.9-1']

There is another issue:

fabric.noarch: E: non-executable-script /usr/lib/python2.5/site-packages/fabric.py 0644

SRPM:
[fab@laptop24 SRPMS]$ rpmlint fab*
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=942633

(In reply to comment #3)
> (In reply to comment #1) 
> > - Do you really need 'Requires: python-setuptools' ?
> 
> Yes, it is a requirement.

I'm able to build this package without 'Requires: python-setuptools'.  But I'm not very familiar with the *.egg stuff.  I thought that 'BuildRequires: python-setuptools-devel' is responsible for providing the egg.
Comment 5 Silas Sewell 2008-11-20 21:45:43 EST
(In reply to comment #4)
> Please bump the release of your spec file if you made any changes and add a
> changelog entry. 

Fixed.

> fabric.noarch: E: non-executable-script
> /usr/lib/python2.5/site-packages/fabric.py 0644

fabric.py is never called directly (and would not do anything if it was) and site-packages modules generally don't have the executable permission.

This issue was also raised in this request: https://bugzilla.redhat.com/show_bug.cgi?id=351251

Example:

[ssewell@gm ~]$ ll /usr/lib/python2.5/site-packages/*.py
-rw-r--r-- 1 root root 14299 2008-04-03 10:14 /usr/lib/python2.5/site-packages/aotcompile.py
-rw-r--r-- 1 root root 32345 2008-08-25 15:06 /usr/lib/python2.5/site-packages/audit.py
-rw-r--r-- 1 root root 10245 2008-07-03 05:36 /usr/lib/python2.5/site-packages/augeas.py
-rw-r--r-- 1 root root  7389 2006-08-22 08:18 /usr/lib/python2.5/site-packages/classfile.py
-rw-r--r-- 1 root root    33 2008-08-05 00:05 /usr/lib/python2.5/site-packages/dbus_bindings.py
...

> I'm able to build this package without 'Requires: python-setuptools'.  But I'm
> not very familiar with the *.egg stuff.  I thought that 'BuildRequires:
> python-setuptools-devel' is responsible for providing the egg.

You are correct, but the requirement comes from the import of pkg_resources in the "fab" command. If python-setuptools is not installed on the local machine the "fab" command will not run.

/usr/bin/fab:

  5 from pkg_resources import load_entry_point
  6 
  7 sys.exit(
  8    load_entry_point('Fabric==0.0.9', 'console_scripts', 'fab')()
  9 )

PkgResources: http://peak.telecommunity.com/DevCenter/PkgResources

== Updated Media ==

Spec URL:
http://silassewell.googlecode.com/svn/trunk/projects/rpm/fabric/fabric.spec
SRPM URL:
http://silassewell.googlecode.com/svn/trunk/projects/rpm/fabric/fabric-0.0.9-3.fc9.src.rpm

Thanks again,
Comment 6 Fabian Affolter 2008-12-08 04:07:12 EST
If you are still seeking a sponsor, refer to https://fedoraproject.org/wiki/PackageMaintainers/HowToGetSponsored
Comment 7 Silas Sewell 2008-12-10 00:31:28 EST
If someone would like to sponsor this package I will be happy to maintain it, otherwise I won't clog up the ticketing system.
Comment 8 Fabian Affolter 2008-12-10 09:07:54 EST
The package needs a maintainer and you need a sponsor to maintain the package.

Did you close the bug?
Comment 9 Silas Sewell 2008-12-10 11:02:49 EST
Yes, I did close the request. I briefer contributing code and I don't have the time/desire to woo a sponsor.

I'm just going to maintain the package externally.

http://code.google.com/p/silassewell/wiki/Packages

Sorry for wasting your time.
Comment 10 Silas Sewell 2009-02-21 23:42:22 EST
I have some more time now, so I'm going to re-open this review and try to get sponsored.
Comment 11 Silas Sewell 2009-02-22 14:09:26 EST
Updated package to version 0.1.0 and Python requirement to version 2.5

Spec URL:
http://silassewell.googlecode.com/svn/trunk/projects/packages/rpms/fabric/fabric.spec
SRPM URL:
http://silassewell.googlecode.com/files/fabric-0.1.0-1.src.rpm
Comment 12 Fabian Affolter 2009-03-07 18:52:42 EST
There is a rpmlint warning

[fab@laptop24 SRPMS]$ rpmlint fabric-0.1.0-1.src.rpm 
fabric.src: W: non-coherent-filename fabric-0.1.0-1.src.rpm fabric-0.1.0-1.fc10.src.rpm
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
Comment 13 Silas Sewell 2009-03-07 19:29:21 EST
I can provide a separate download if you want it with the ".fc10." in the filename, but as I'm pushing for everyone else until it gets into Fedora, I'm going to leave that link as-is.

Anyway, with it renamed:

[silas@pluto ~]$ wget --quiet http://silassewell.googlecode.com/files/fabric-0.1.0-1.src.rpm -O fabric-0.1.0-1.fc10.src.rpm && rpmlint fabric-0.1.0-1.fc10.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

The RPM will also have an error which as mentioned in #5 is fine:

[silas@pluto ~]$ rpmlint fabric-0.1.0-1.fc10.noarch.rpm 
fabric.noarch: E: non-executable-script /usr/lib/python2.5/site-packages/fabric.py 0644
1 packages and 0 specfiles checked; 1 errors, 0 warnings.
Comment 15 Silas Sewell 2009-03-29 15:29:27 EDT
Fix dependencies and non-executable-script error

SRPM: http://silassewell.googlecode.com/files/fabric-0.1.0-3.fc10.src.rpm

Diff: http://code.google.com/p/silassewell/source/diff?spec=svn213&old=204&r=214&format=side&path=%2Ftrunk%2Fprojects%2Fpackages%2Frpms%2Ffabric%2Ffabric.spec

rpmlint

$ rpmlint fabric-0.1.0-3.fc10.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint fabric-0.1.0-3.fc10.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
Comment 16 Silas Sewell 2009-04-10 02:12:05 EDT
Changelog:
- Update to 0.1.1
- Up Paramiko version dependency to 1.7
- Remove Python version dependency
- Make sed safer

SRPM: http://silassewell.googlecode.com/files/fabric-0.1.1-1.fc10.src.rpm

Diff: http://code.google.com/p/silassewell/source/diff?spec=svn221&r=221&format=side&path=/trunk/projects/packages/rpms/fabric/fabric.spec

rpmlint

silas@silas ~]$ rpmlint fabric-0.1.1-1.fc10.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[silas@silas ~]$ rpmlint fabric-0.1.1-1.fc10.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
Comment 17 Jonathan Steffan 2009-04-10 17:50:21 EDT
# MUST: rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint fabric-0.1.1-1.fc10.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint fabric-0.1.1-1.fc10.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

# MUST: The package must be named according to the Package Naming Guidelines.

PASSED

# MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

http://silassewell.googlecode.com/svn/trunk/projects/packages/rpms/fabric/fabric.spec

PASSED

# MUST: The package must meet the Packaging Guidelines.

PASSED

# MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.

GPLv2+

PASSED

# MUST: The License field in the package spec file must match the actual license.

http://www.nongnu.org/fab/index.html -- Bottom of page

PASSED

# MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

http://silassewell.googlecode.com/svn/trunk/projects/packages/rpms/fabric/fabric.spec

%doc LICENSE ...

PASSED

# MUST: The spec file must be written in American English.

PASSED

# MUST: The spec file for the package MUST be legible.

PASSED

# MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

$ curl -s http://savannah.inetbridge.net/fab/fab-0.1.1.tar.gz | md5sum 
b317a951d44abb2649b86c0539dadd3b  -
$ curl -sO http://silassewell.googlecode.com/files/fabric-0.1.1-1.fc10.src.rpm && rpmdev-extract fabric-0.1.1-1.fc10.src.rpm &> /dev/null && md5sum fabric-0.1.1-1.fc10.src/fab-0.1.1.tar.gz 
b317a951d44abb2649b86c0539dadd3b  fabric-0.1.1-1.fc10.src/fab-0.1.1.tar.gz

# MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

PASSWD

# MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.

PASSED

# MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

PASSED

# MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

PASSED

# MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

PASSED

# MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

PASSED

# MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

PASSED

# MUST: A Fedora package must not list a file more than once in the spec file's %files listings.

PASSED

# MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.

PASSED

# MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

PASSED

# MUST: Each package must consistently use macros.

PASSED

# MUST: The package must contain code, or permissable content.

PASSED

# MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

PASSED

# MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

PASSED

# MUST: Header files must be in a -devel package.

PASSED

# MUST: Static libraries must be in a -static package.

PASSED

# MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).

PASSED

# MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.

PASSED

# MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}

PASSED

# MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

PASSED

# MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

PASSED

# MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

PASSED

# MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

PASSED

# MUST: All filenames in rpm packages must be valid UTF-8.

PASSED

---------------------------------------------------
  This package (fabric) is APPROVED by jsteffan
---------------------------------------------------
Comment 18 Silas Sewell 2009-04-10 17:59:08 EDT
New Package CVS Request
=======================
Package Name: fabric
Short Description: A simple Pythonic remote deployment tool
Owners: silas
Branches:
InitialCC:
Comment 19 Kevin Fenzi 2009-04-12 14:19:49 EDT
cvs done.
Comment 20 Silas Sewell 2009-04-12 14:59:52 EDT
Built.

Thanks Fabian, Jonathan and Kevin.
Comment 21 Athmane Madjoudj 2013-05-21 08:47:19 EDT
Package Change Request
======================
Package Name: fabric
New Branches: el6
Owners: athmane
Comment 22 Athmane Madjoudj 2013-05-21 08:50:48 EDT
Hi Silas,

I'd like to maintain a EPEL branch of fabric pkg, also if you need a co-maintainer for Fedora branches, I'll be happy to help.

FAS account: athmane

Thanks.
Comment 23 Gwyn Ciesla 2013-05-23 11:27:08 EDT
Any comments from the Fedora maintainer?
Comment 24 Athmane Madjoudj 2013-07-31 08:07:58 EDT
Hi Jon / SCM admins,

Silas added me as co-maintainer for fedora branches, so I guess it's safe to approve EPEL6 branch SCM request.

Thanks.
Comment 25 Gwyn Ciesla 2013-07-31 08:17:37 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.